(* activation_records.ml: simple function calls to demonstrate how
   functions stack up *)
open Printf;;

let dub_sqr x =
  let sq = x*x in
  2 * sq
;;

let mult_ds x y =
  let xx = dub_sqr x in
  let yy = dub_sqr y in
  xx * yy
;;

let main () =
  let z = 7 in
  let w = 2 in
  let mzw = mult_ds z w in
  let dzw = dub_sqr z in
  printf "z: %d  w: %d\n" z w;
  printf "mzw: %d\n" mzw;
  printf "dzw: %d\n" dzw;
;;

main ();;
